package com.dsic.gj_erp.wsclient.handler;

import cn.hutool.cron.CronUtil;
import cn.hutool.cron.task.Task;
import com.alibaba.fastjson.JSONObject;
import com.dsic.gj_erp.wsclient.Message;
import com.dsic.gj_erp.wsclient.WebSocketService;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;

@Service
@RequiredArgsConstructor
public class HeartHandler implements IHandlerService{

    private final WebSocketService webSocketService;

    private boolean scheduleStartFlag=false;

    @Override
    public boolean execute(Message message) {
        if (this.scheduleStartFlag){
            return true;
        }
        CronUtil.schedule("*/30 * * * * *", (Task) () -> {
            try {
                System.out.println("心跳");
                webSocketService.sendMessage(message.toString());
            } catch (Exception e) {
                e.printStackTrace();
            }
        });

        // 支持秒级别定时任务
        CronUtil.setMatchSecond(true);
        CronUtil.start();
        this.scheduleStartFlag=true;
        return true;
    }
}
